
public class bachUpwithdate
{
    [DeclareAction("BackUpWithDate")]
	public void MyBackUp()
	{
      
        string myTime = System.DateTime.Now.ToShortDateString();
        string hour = System.DateTime.Now.Hour.ToString();
        string minute = System.DateTime.Now.Minute.ToString();
        string Project = string.Empty;

        Project = GetProject();


        Progress progress = new Progress("SimpleProgress");
        progress.BeginPart(100, "");
        progress.SetAllowCancel(true);
        if (!progress.Canceled())
        {
            progress.BeginPart(33, "GenerateConnections");
            ActionCallingContext generateConnectionsContext = new ActionCallingContext();
            generateConnectionsContext.AddParameter("LogMsgActionDone", "true");
            generateConnectionsContext.AddParameter("PROJECTNAME", Project);
            generateConnectionsContext.AddParameter("TYPE", "CONNECTIONS");
            new CommandLineInterpreter().Execute("generate", generateConnectionsContext);
            progress.EndPart();
        }

        if (!progress.Canceled())
        {
            progress.BeginPart(33, "UpdateReports");
            ActionCallingContext updateReportsContext = new ActionCallingContext();
            updateReportsContext.AddParameter("LogMsgActionDone", "true");
            updateReportsContext.AddParameter("PROJECTNAME", Project);
            updateReportsContext.AddParameter("TYPE", "PROJECT");
            new CommandLineInterpreter().Execute("reports", updateReportsContext);
            progress.EndPart();
        }

        if (!progress.Canceled())
        {
            progress.BeginPart(33, "Backup");
            ActionCallingContext backupContext = new ActionCallingContext();
            backupContext.AddParameter("BACKUPMEDIA", "DISK");
            backupContext.AddParameter("BACKUPMETHOD", "BACKUP");
            backupContext.AddParameter("COMPRESSPRJ", "0");
            backupContext.AddParameter("INCLEXTDOCS", "1");
            backupContext.AddParameter("BACKUPAMOUNT", "BACKUPAMOUNT_ALL");
            backupContext.AddParameter("INCLIMAGES", "1");
            backupContext.AddParameter("LogMsgActionDone", "true");
            backupContext.AddParameter("DESTINATIONPATH", @"D:\temp");
            backupContext.AddParameter("PROJECTNAME", Project);
            backupContext.AddParameter("TYPE", "PROJECT");
            backupContext.AddParameter("ARCHIVENAME", Project + "_" + hour + "." + minute + "h_" + myTime);
            new CommandLineInterpreter().Execute("backup", backupContext);
            progress.EndPart();
        }
       
        progress.EndPart(true);
		return;
	}
    public string GetProject()
    {

        string strProject = "";

        ActionCallingContext ProjectContext = new ActionCallingContext();
        ProjectContext.AddParameter("TYPE", "PROJECT");

        new CommandLineInterpreter().Execute("selectionset", ProjectContext);
        ProjectContext.GetParameter("PROJECT", ref strProject);

        return strProject;
    }
}
